
%{
#ifndef lint
static char rcsid[] = "$Header: lisp.l,v 0.0 88/06/22 05:22:11 on Rel $";
#endif
#include <ctype.h>
#include "pps.h"

int def;
%}
letter	[@A-Za-z_\-:\$]
digit	[0-9]
white	[ \t]
%Start COMMENT STRING1 STRING2 KEYWORD
%%
<INITIAL>c[ad]+r	{ begin(KEYWORD); ECHO; begin(INITIAL); }
<INITIAL>def	{ def++; REJECT; }
<INITIAL>{letter}({letter}|{digit})*	{	/* BUG */
			int kw = iskw(yytext);

			if (kw)
				begin(KEYWORD);
			else if (def) {
				funct(yytext);
				def = 0;
			}
			ECHO;
			if (kw)
				begin(INITIAL);
		}
<INITIAL>\"	{ begin(STRING1); ECHO; }
<INITIAL>\#	{ begin(COMMENT); ECHO; begin(INITIAL); }
<INITIAL>;	{ begin(COMMENT); ECHO; begin(INITIAL); }
<STRING1>\\.	{ ECHO; }
<STRING1>\"	{ ECHO; begin(INITIAL); }
[\t\n\f]+	{ space(yytext); }
.		{ ECHO; }
%%
/*
 * Your pet lisp dialect has other built-ins than ours;
 * anyway, the list is too long to ship over the net...
 */
char *keywords[] = {
	"",
	"%",
	"*",
	"+",
	"-",
	"/",
	"/=",
	"1+",
	"1-",
	"<",
	"<=",
	"=",
	">",
	">=",
	"`",
	"abort-recursive-edit",
	"accept-process-output",
	"accessible-keymaps",
	"advertised-undo",
	"all-completions",
	"and",
	"append",
	"append-to-buffer",
	"append-to-file",
	"append-to-register",
	"apply",
	"apropos",
	"aref",
	"arrayp",
	"aset",
	"ash",
	"assoc",
	"assq",
	"atom",
	"autoload",
	"back-to-indentation",
	"backward-char",
	"backward-delete-char",
	"backward-delete-char-untabify",
	"backward-kill-paragraph",
	"backward-kill-sentence",
	"backward-kill-sexp",
	"backward-kill-word",
	"backward-list",
	"backward-page",
	"backward-paragraph",
	"backward-prefix-chars",
	"backward-sentence",
	"backward-sexp",
	"backward-to-indentation",
	"backward-up-list",
	"backward-word",
	"baud-rate",
	"beep",
	"beginning-of-buffer",
	"beginning-of-defun",
	"beginning-of-line",
	"blink-matching-open",
	"bobp",
	"bolp",
	"boundp",
	"buffer-enable-undo",
	"buffer-end",
	"buffer-file-name",
	"buffer-flush-undo",
	"buffer-list",
	"buffer-local-variables",
	"buffer-menu",
	"buffer-modified-p",
	"buffer-name",
	"buffer-size",
	"buffer-string",
	"buffer-substring",
	"bufferp",
	"byte-code",
	"byte-compile-file",
	"byte-recompile-directory",
	"call-interactively",
	"call-last-kbd-macro",
	"call-process",
	"call-process-region",
	"cancel-debug-on-entry",
	"capitalize",
	"capitalize-region",
	"capitalize-word",
	"car",
	"car-safe",
	"catch",
	"cdr",
	"cdr-safe",
	"char-after",
	"char-equal",
	"char-or-string-p",
	"char-syntax",
	"char-to-string",
	"clear-rectangle",
	"compare-windows",
	"completing-read",
	"concat",
	"cond",
	"condition-case",
	"cons",
	"consp",
	"copy-alist",
	"copy-file",
	"copy-keymap",
	"copy-marker",
	"copy-rectangle-to-register",
	"copy-region-as-kill",
	"copy-sequence",
	"copy-syntax-table",
	"copy-to-buffer",
	"copy-to-register",
	"count-lines",
	"count-lines-page",
	"count-lines-region",
	"count-matches",
	"current-buffer",
	"current-column",
	"current-global-map",
	"current-indentation",
	"current-local-map",
	"current-time-string",
	"current-window-configuration",
	"debug",
	"debug-on-entry",
	"default-value",
	"defconst",
	"define-key",
	"define-prefix-command",
	"defmacro",
	"defmath",
	"defun",
	"defvar",
	"delete-backward-char",
	"delete-blank-lines",
	"delete-char",
	"delete-extract-rectangle",
	"delete-file",
	"delete-horizontal-space",
	"delete-indentation",
	"delete-matching-lines",
	"delete-non-matching-lines",
	"delete-other-windows",
	"delete-process",
	"delete-rectangle",
	"delete-region",
	"delete-window",
	"delete-windows-on",
	"delq",
	"digit-argument",
	"ding",
	"disable-command",
	"disabled-command-hook",
	"disassemble",
	"discard-input",
	"display-buffer",
	"display-completion-list",
	"dot",
	"dot-marker",
	"dot-max",
	"dot-min",
	"down-list",
	"downcase",
	"downcase-region",
	"downcase-word",
	"emacs-version",
	"enable-command",
	"end-of-buffer",
	"end-of-defun",
	"end-of-line",
	"end-of-paragraph-text",
	"enlarge-window",
	"enlarge-window-horizontally",
	"eobp",
	"eolp",
	"eq",
	"eql",
	"equal",
	"erase-buffer",
	"error",
	"eval",
	"eval-current-buffer",
	"eval-defun",
	"eval-expression",
	"eval-last-sexp",
	"eval-minibuffer",
	"eval-print-last-sexp",
	"eval-region",
	"exchange-dot-and-mark",
	"exchange-point-and-mark",
	"execute-extended-command",
	"execute-kbd-macro",
	"exit-minibuffer",
	"exit-recursive-edit",
	"expand-file-name",
	"expand-region-abbrevs",
	"extract-rectangle",
	"fboundp",
	"featurep",
	"fmakunbound",
	"following-char",
	"format",
	"forward-char",
	"forward-line",
	"forward-list",
	"forward-page",
	"forward-paragraph",
	"forward-sentence",
	"forward-sexp",
	"forward-to-indentation",
	"forward-word",
	"fset",
	"ftoc",
	"funcall",
	"function",
	"function-called-at-point",
	"function-key-sequence",
	"garbage-collect",
	"generate-new-buffer",
	"get",
	"get-buffer",
	"get-buffer-create",
	"get-buffer-process",
	"get-buffer-window",
	"get-file-buffer",
	"get-file-char",
	"get-largest-window",
	"get-lru-window",
	"get-process",
	"get-register",
	"getenv",
	"global-key-binding",
	"global-set-key",
	"global-unset-key",
	"goto-char",
	"goto-line",
	"identity",
	"if",
	"ignore",
	"indent-according-to-mode",
	"indent-c-exp",
	"indent-code-rigidly",
	"indent-for-comment",
	"indent-for-tab-command",
	"indent-new-comment-line",
	"indent-region",
	"indent-relative",
	"indent-relative-maybe",
	"indent-rigidly",
	"indent-sexp",
	"indent-to",
	"indent-to-column",
	"indent-to-left-margin",
	"input-pending-p",
	"insert",
	"insert-before-markers",
	"insert-buffer",
	"insert-buffer-substring",
	"insert-char",
	"insert-file",
	"insert-file-contents",
	"insert-kbd-macro",
	"insert-parentheses",
	"insert-rectangle",
	"insert-register",
	"insert-string",
	"insert-tab",
	"int-to-string",
	"integer-or-marker-p",
	"integerp",
	"interactive",
	"interactive-p",
	"intern",
	"intern-soft",
	"interrupt-process",
	"just-one-space",
	"justify-current-line",
	"kbd-macro-query",
	"keep-lines",
	"key-binding",
	"key-description",
	"keyboard-quit",
	"keymapp",
	"keypad-default",
	"kill-append",
	"kill-backward-chars",
	"kill-buffer",
	"kill-comment",
	"kill-compilation",
	"kill-emacs",
	"kill-forward-chars",
	"kill-grep",
	"kill-line",
	"kill-line-twice",
	"kill-local-variable",
	"kill-paragraph",
	"kill-process",
	"kill-rectangle",
	"kill-region",
	"kill-ring-save",
	"kill-sentence",
	"kill-sexp",
	"kill-some-buffers",
	"kill-word",
	"length",
	"let",
	"let*",
	"list-buffers",
	"list-command-history",
	"list-directory",
	"list-matching-lines",
	"list-options",
	"list-processes",
	"list-tags",
	"listp",
	"load",
	"load-file",
	"load-library",
	"local-key-binding",
	"local-set-key",
	"local-unset-key",
	"lock-buffer",
	"logand",
	"logior",
	"lognot",
	"logxor",
	"looking-at",
	"lookup-key",
	"macroexpand",
	"make-backup-file-name",
	"make-command-summary",
	"make-keymap",
	"make-list",
	"make-local-variable",
	"make-marker",
	"make-sparse-keymap",
	"make-string",
	"make-symbol",
	"make-symbolic-link",
	"make-syntax-table",
	"make-temp-name",
	"make-variable-buffer-local",
	"make-vector",
	"makunbound",
	"mapatoms",
	"mapcar",
	"mapconcat",
	"mark",
	"mark-c-function",
	"mark-defun",
	"mark-end-of-sentence",
	"mark-marker",
	"mark-page",
	"mark-paragraph",
	"mark-sexp",
	"mark-whole-buffer",
	"mark-word",
	"marker-buffer",
	"marker-position",
	"markerp",
	"match-beginning",
	"match-data",
	"match-end",
	"matching-substring",
	"max",
	"memq",
	"message",
	"min",
	"minibuffer-complete",
	"minibuffer-complete-and-exit",
	"minibuffer-complete-word",
	"minibuffer-completion-help",
	"minibuffer-depth",
	"minibuffer-window",
	"mod",
	"mode-specific-command-prefix",
	"modify-syntax-entry",
	"momentary-string-display",
	"move-marker",
	"move-past-close-and-reindent",
	"move-to-column",
	"move-to-window-line",
	"name-last-kbd-macro",
	"narrow-to-page",
	"narrow-to-region",
	"natnump",
	"nconc",
	"negative-argument",
	"newline",
	"newline-and-indent",
	"next-complex-command",
	"next-error",
	"next-file",
	"next-line",
	"next-window",
	"nil",
	"nlistp",
	"nonincremental-search",
	"not",
	"not-modified",
	"nreverse",
	"nroff-mode",
	"nth",
	"nthcdr",
	"null",
	"numberp",
	"one-window-p",
	"open-line",
	"open-network-stream",
	"open-rectangle",
	"or",
	"other-buffer",
	"other-window",
	"parse-partial-sexp",
	"perform-replace",
	"point",
	"point-marker",
	"point-max",
	"point-max-marker",
	"point-min",
	"point-min-marker",
	"point-to-register",
	"pop-mark",
	"pop-to-buffer",
	"pos-visible-in-window-p",
	"preceding-char",
	"prefix-arg-internal",
	"prefix-numeric-value",
	"prepend-to-buffer",
	"prepend-to-register",
	"previous-complex-command",
	"previous-line",
	"previous-window",
	"primitive-undo",
	"prin1",
	"prin1-to-string",
	"princ",
	"print",
	"print-buffer",
	"print-help-return-message",
	"print-region",
	"process-buffer",
	"process-command",
	"process-exit-status",
	"process-filter",
	"process-id",
	"process-kill-without-query",
	"process-list",
	"process-mark",
	"process-name",
	"process-send-eof",
	"process-send-region",
	"process-send-string",
	"process-sentinel",
	"process-status",
	"processp",
	"prog1",
	"prog2",
	"progn",
	"prolog-mode",
	"provide",
	"push-mark",
	"put",
	"quit-process",
	"quote",
	"quoted-insert",
	"random",
	"rassq",
	"re-search-backward",
	"re-search-forward",
	"read",
	"read-buffer",
	"read-char",
	"read-command",
	"read-file-name",
	"read-file-name-internal",
	"read-from-minibuffer",
	"read-from-string",
	"read-input",
	"read-key-sequence",
	"read-minibuffer",
	"read-no-blanks-input",
	"read-quoted-char",
	"read-string",
	"read-variable",
	"recursion-depth",
	"recursive-edit",
	"redraw-display",
	"regexp-quote",
	"region-beginning",
	"region-end",
	"register-to-point",
	"rename-auto-save-file",
	"rename-buffer",
	"rename-file",
	"repeat-complex-command",
	"repeat-matching-complex-command",
	"replace-buffer-in-windows",
	"replace-match",
	"replace-regexp",
	"replace-string",
	"require",
	"reverse",
	"revert-buffer",
	"rotate-yank-pointer",
	"rplaca",
	"rplacd",
	"run-hooks",
	"save-buffer",
	"save-buffers-kill-emacs",
	"save-excursion",
	"save-loaded-file",
	"save-restriction",
	"save-some-buffers",
	"save-window-excursion",
	"scan-lists",
	"scan-sexps",
	"screen-height",
	"screen-width",
	"scribe-mode",
	"scroll-down",
	"scroll-left",
	"scroll-other-window",
	"scroll-right",
	"scroll-up",
	"search-backward",
	"search-forward",
	"select-another-buffer",
	"select-window",
	"selected-window",
	"self-insert-and-exit",
	"self-insert-command",
	"send-region",
	"send-string",
	"send-string-to-terminal",
	"sequencep",
	"server-start",
	"set",
	"set-auto-mode",
	"set-buffer",
	"set-buffer-auto-saved",
	"set-buffer-modified-p",
	"set-comment-column",
	"set-default",
	"set-fill-column",
	"set-fill-prefix",
	"set-goal-column",
	"set-input-mode",
	"set-mark",
	"set-mark-command",
	"set-marker",
	"set-process-buffer",
	"set-process-filter",
	"set-process-sentinel",
	"set-register",
	"set-screen-height",
	"set-screen-width",
	"set-selective-display",
	"set-syntax-table",
	"set-variable",
	"set-visited-file-name",
	"set-window-buffer",
	"set-window-configuration",
	"set-window-dot",
	"set-window-hscroll",
	"set-window-point",
	"set-window-start",
	"setcar",
	"setcdr",
	"setplist",
	"setq",
	"setq-default",
	"setup-terminal-keymap",
	"shell-command",
	"shell-command-on-region",
	"show-buffer",
	"shrink-window",
	"shrink-window-horizontally",
	"signal",
	"single-key-description",
	"sit-for",
	"skip-chars-backward",
	"skip-chars-forward",
	"sleep-for",
	"sort",
	"sort-columns",
	"sort-fields",
	"sort-lines",
	"sort-numeric-fields",
	"sort-pages",
	"sort-paragraphs",
	"sort-regexp-fields",
	"split-line",
	"split-window",
	"split-window-horizontally",
	"split-window-vertically",
	"standard-syntax-table",
	"start-kbd-macro",
	"start-of-paragraph-text",
	"start-process",
	"stop-process",
	"store-match-data",
	"string-equal",
	"string-lessp",
	"string-match",
	"string-replace-regexp-alist",
	"string-subst-char",
	"string-to-char",
	"string-to-int",
	"string<",
	"string=",
	"stringp",
	"subrp",
	"subst-char-in-region",
	"substitute-command-keys",
	"substitute-in-file-name",
	"substitute-key-definition",
	"substring",
	"suppress-keymap",
	"suspend-emacs",
	"swap-window-positions",
	"switch-to-buffer",
	"switch-to-buffer-other-window",
	"symbol-function",
	"symbol-name",
	"symbol-plist",
	"symbol-value",
	"symbolp",
	"syntax-table",
	"syntax-table-p",
	"system-name",
	"t",
	"tab-to-tab-stop",
	"tabify",
	"terpri",
	"text-char-description",
	"this-command-keys",
	"throw",
	"toggle-read-only",
	"top-level",
	"transpose-chars",
	"transpose-lines",
	"transpose-paragraphs",
	"transpose-sentences",
	"transpose-sexps",
	"transpose-subr",
	"transpose-subr-1",
	"transpose-words",
	"try-completion",
	"turn-on-auto-fill",
	"undefined",
	"underline-region",
	"undo",
	"undo-boundary",
	"undo-more",
	"undo-start",
	"unexpand-abbrev",
	"universal-argument",
	"unlock-buffer",
	"untabify",
	"ununderline-region",
	"unwind-protect",
	"up-list",
	"upcase",
	"upcase-region",
	"upcase-word",
	"use-global-map",
	"use-local-map",
	"user-full-name",
	"user-login-name",
	"user-real-login-name",
	"user-real-uid",
	"user-uid",
	"user-variable-p",
	"variable-at-point",
	"vconcat",
	"vector",
	"vectorp",
	"verify-visited-file-modtime",
	"vertical-motion",
	"view-buffer",
	"view-file",
	"view-lossage",
	"view-mode",
	"view-register",
	"waiting-for-user-input-p",
	"what-cursor-position",
	"what-line",
	"what-page",
	"where-is",
	"where-is-internal",
	"while",
	"widen",
	"window-buffer",
	"window-dot",
	"window-edges",
	"window-height",
	"window-hscroll",
	"window-point",
	"window-start",
	"window-width",
	"windowp",
	"with-output-to-temp-buffer",
	"word-search-backward",
	"word-search-forward",
	"write-char",
	"write-file",
	"write-region",
	"y-or-n-p",
	"yank",
	"yank-pop",
	"yank-rectangle",
	"yes-or-no-p",
	"zap-to-char",
	"zerop",
	NULL
};

char *directives[] = {
	"",
	NULL
};

